EVP_PKEY_NEW(3)

NAME
EVP_PKEY_new, EVP_PKEY_up_ref, EVP_PKEY_free - private key allocation functions

SYNOPSIS
#include <openssl/evp.h>
EVP_PKEY *
EVP_PKEY_new(void);
int
EVP_PKEY_up_ref(EVP_PKEY *key);
void
EVP_PKEY_free(EVP_PKEY *key);

DESCRIPTION
The EVP_PKEY structure is used by various OpenSSL functions which require a general private key without reference to any particular algorithm.

The EVP_PKEY_new() function allocates an empty EVP_PKEY structure. The reference count is set to 1. To add a private key to it, use the functions described in EVP_PKEY_set1_RSA(3).

EVP_PKEY_up_ref() increments the reference count of key by 1.

EVP_PKEY_free() decrements the reference count of key by 1, and if the reference count reaches zero, frees it up. If key is a NULL pointer, no action occurs.

RETURN VALUES
EVP_PKEY_new() returns either the newly allocated EVP_PKEY structure or NULL if an error occurred.

EVP_PKEY_up_ref() returns 1 for success or 0 for failure.

SEE ALSO
EVP_PKEY_asn1_set_free(3), EVP_PKEY_set1_RSA(3)

HISTORY
EVP_PKEY_new() and EVP_PKEY_free() appeared in SSLeay 0.8.1b or earlier and have been available since OpenBSD 2.4.

EVP_PKEY_up_ref() first appeared in OpenSSL 1.1.0 and has been available since OpenBSD 6.3.